package peg;

public class Seq implements Parser {
	public Parser p1;
	public Parser p2;
	
	public Seq(Parser _p1, Parser _p2) {
		p1 = _p1;
		p2 = _p2;
	}
	
	public Seq(Parser... ps) {
		if(ps.length < 2)
			throw new RuntimeException("seq precisa de pelo menos dois elementos");
		p1 = ps[0];
		if(ps.length == 2) {
			p2 = ps[1];
		} else {
			Parser[] nps = new Parser[ps.length-1];
			for(int i = 1; i < ps.length; i++) {
				nps[i-1] = ps[i];
			}
			p2 = new Seq(nps);
		}
	}
	
	@Override
	public State<Character> parse(State<Character> st) {
		State<Character> res1 = p1.parse(st);
		if(res1.input != null)
			return p2.parse(res1);
		else {
			return res1;
		}
	}

}

